<?php

include "vendor/autoload.php";

function dump($response) {
    [$resp, $status] = $response;
    if($status->code == \Grpc\STATUS_OK) {
        $res = $resp->getInfo();
        if(isset($res["username"])){
            echo "username: ". $res["username"] ."\ntoken:" . $resp->getToken(). "\n";
        }else{
            echo $resp->getMsg() . "\n";
        }
       
    }else{
        echo "error infomation:" . $status->details . "\n";
    }
}

$client = new \Proto\UserClient("127.0.0.1:1234", ["credentials" => \Grpc\ChannelCredentials::createInsecure()]);

$registerRequest = new \Proto\RegisterRequest();

$registerRequest->setUsername("test");
$registerRequest->setPassword("test123");
$registerRequest->setEmail("test@widuu.com");
$registerRequest->setHobbies(["basketball", "football"]);

dump($client->Register($registerRequest)->wait());


$loginRequest = new \Proto\LoginRequest();
$loginRequest->setUsername("test");
$loginRequest->setPassword("test123");

dump($client->Login($loginRequest)->wait());
dump($client->GetUserInfo(new \Google\Protobuf\GPBEmpty())->wait());
